# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b246"
os.chdir("/Users/was/.sage/sage_notebook/worksheets/admin/104/cells/42")
sage.server.notebook.interact.SAGE_CELL_ID=42
import random

def ftree(rows, v, i, F):
    if len(v) > Integer(0):
        # add a row to g at the ith level.
        rows.append(v)
    w = []
    for i in range(len(v)):
        k, _,_ = v[i]
        if k is None or is_prime(k):
            w.append((None,None,None))
        else:
            d = random.choice(divisors(k)[Integer(1):-Integer(1)])
            w.append((d,k,i))
            e = k//d
            if e == Integer(1):
                w.append((None,None))
            else:
                w.append((e,k,i))
    if len(w) > len(v):
        ftree(rows, w, i+Integer(1), F)


def draw_ftree(rows,font):
    g = Graphics()
    for i in range(len(rows)):
        cur = rows[i]
        for j in range(len(cur)):
            e, f, k = cur[j]
            if not e is None:
                if is_prime(e):
                     c = (Integer(1),Integer(0),Integer(0))
                else:
                     c = (Integer(0),Integer(0),RealNumber('.4'))
                g += text(str(e), (j*Integer(2)-len(cur),-i), fontsize=font, rgbcolor=c)
                if not k is None and not f is None:
                    g += line([(j*Integer(2)-len(cur),-i), ((k*Integer(2))-len(rows[i-Integer(1)]),-i+Integer(1))],
                    alpha=RealNumber('0.5'))
    return g

@interact
def factor_tree(n=Integer(100), font=Integer(10)):
    rows = []
    v = [(n,None,Integer(0))]
    ftree(rows, v, Integer(0), factor(n))
    show(draw_ftree(rows, font), axes=False)

print "e246"
